                
<BODY BGColor=#264c73 TEXT=White LINK=White ALINK=#9999FF vlink=White leftmargin=0 topmargin=0>
                                         
<style>       
<!--
    A:link {text-decoration: none;}
    A:visited {text-decoration: none;}
    A:active {text-decoration: none;}
    A:hover {text-decoration: none;}
-->
</style>

<SCRIPT LANGUAGE=JavaScript>
function display(stuff) {
 window.status = stuff;
 return true;           
}
</script>

<?PHP

//------------------------------------------------------------------------------------------
//
// ---------------------------------------------------
// copyright 2000 by voxeo corporation. (see LGPL.txt)
// ---------------------------------------------------
//
// v1.0 Coded in PHP 4.0
// v1.0 Coded by Stephen J. Lewis
//
// This file is the main web-based script for editing the AutoAttendant 
// database file.  It is associated with the following files:
//		AutoAttendantWorkHorse.php  <---- PHP file that saves the information
//										  from the forms of this script.
//		AutoAttendantDB             <---- Database file
//		AutoAttendant.php			<---- generates CallXML from the database
//		CallDestination.xml			|
//									|---- handles the calling and conferencing
//		DoTheCall.xml				|
//
//      passwords.inc               <---- Abstracted functions for HTTP and FTP
//                                        passwords.
//      Database-Linux.inc          <---- This contains all the abstracted database
//                                        routines for linux.
//      Database-Win32.inc          <---- This contains all the abstracted database
//                                        routines for Win32.
//
// The database is either an Interbase resource or MS Access file
// and contains one table, named AutoAttendantDB, with columns called:
//  	'Digit,'      'AudioURL,'     'Destination,' 'MenuName,' 
// 		'ActionType,' 'MenuPosition,' and 'UniqueID.'
//-------------------------------------------------------------------------------------------


//-----------------------------------------------------
// This little tweak is in case we are running under an
// Operating System that use case-sensitive URLs.
//-----------------------------------------------------

if ($HTTP_GET_VARS["os"] != "") { $HTTP_GET_VARS["OS"] = $HTTP_GET_VARS["os"]; }

$HTTP_GET_VARS["OS"] = strtolower($HTTP_GET_VARS["OS"]);

if ($HTTP_GET_VARS["OS"] == "linux") { include('database-linux.inc'); }
else 						         { include('database-win32.inc'); }

include('passwords.inc');

//-----------------------------------------------------------------------------------

function DisplayDatabaseTable( $MenuNameToDisplay ) { 
  global $HTTP_GET_VARS;
  
  //------------------------------------------------------
  // Make sure we are pointing to the right database file,
  // depending on the operating system.  These can be 
  // changed depending on the developer's setup and paths.
  //------------------------------------------------------
  
  if ($HTTP_GET_VARS["OS"] == "linux") { 
    $DatabaseName = "/www/html/aa/aa.gdb";
	$Path         = "http://linux1.voxeo.com/aa/";
  }  // if statement
  else { 
    $DatabaseName = "AutoAttendantDB";
    $Path         = "http://appserverdev.voxeo.com/autoattendant/";
  }  // else statement  

  $TempConnection = OpenDatabase($DatabaseName); 
  
  //-------------------------------
  // Query database for information
  //-------------------------------
  
  $TempSQL = "select * from AUTOATTENDANTDB order by MENUNAME";
  
  $TempDataBase = ReadDatabase( $TempConnection, $TempSQL ); 
  
  $MenuNames     = Array();
  $NumberOfMenus = 0;
  
  //-------------------------------------------------
  // We need to build up a list of MenuNames so that
  // we can intelligently build a form drop-down menu
  // later in the code.
  //-------------------------------------------------
  
  while( $TempRow = FetchRowFromDatabase( $TempDataBase ) ) { 
    $MenuName = GetResultFromRow( "MENUNAME", $TempRow, $TempDatabase );
	$Loopy    = 0;
	
	//---------------------------------------------------------------------------
	// Small error check to make sure we do not accept null strings as a MenuName
	//---------------------------------------------------------------------------
	
	if ($MenuName != "") {	
	  //----------------------------------------------------
	  // If NumberOfMenus is 0, then this is our first Menu, 
	  // and thus can be automatically added to the list.
	  //----------------------------------------------------
	
	  if ($NumberOfMenus == 0) {
	    $NumberOfMenus++;
	    $MenuNames[$NumberOfMenus] = $MenuName;
	  }  // if statement
	  else {
	    $Boolean = "MenuNotFound";
		
		//----------------------------------------
		// Loop through our array of MenuNames.
		// If the name already exists, then ignore
		// it because it is not "new."
		//----------------------------------------
		
        for ($Loopy = 1; $Loopy <= $NumberOfMenus; $Loopy++) {		
		  if ($MenuNames[$Loopy] == $MenuName) { 
		    $Boolean = "MenuFound";
		  }  // if statement
		}  // for statement
		
		//--------------------------------------------------
		// If the MenuName was not found, add it to the list
		//--------------------------------------------------
		
		if ($Boolean == "MenuNotFound") {
		  $NumberOfMenus++;
		  $MenuNames[$NumberOfMenus] = $MenuName;
		}  // if statement
	  }  // else statement
	}  // if statement     
  }  // while statement  
  
  //-----------------------------------------------------------
  // Build the 2nd query string; We are allowing the display of 
  // specific menus, so we are passing in a menu name.
  // If the string is empty, then display the entire database.
  //-----------------------------------------------------------
  
  if ( ($MenuNameToDisplay == "") || ($MenuNameToDisplay == "Entire Database") ) {
    $TempMenuName = "Entire Database";
    $TempSQL      = "select * from AUTOATTENDANTDB order by MENUNAME";
	$ReadOnly     = "readonly";
  }  // if statement
  else {
    $TempSQL      = "select * from AUTOATTENDANTDB where MENUNAME = '$MenuNameToDisplay' order by MENUPOSITION";
    $TempMenuName = "$MenuNameToDisplay";
    $ReadOnly     = "";
  }  // else statement

  //---------------------------------------------
  // Query database for information a second time
  //---------------------------------------------
  
  $TempDataBase = ReadDatabase( $TempConnection, $TempSQL ); 
  
  $TableString = "";
  $Loopy       = 0;
  $NewEntry    = "FALSE";
  
  $ActionTypes         = Array("Call", "Menu", "URL", "Greeting", "Hangup");
  $NumberOfActionTypes = 5;
    
  while( $TempRow = FetchRowFromDatabase( $TempDataBase ) ) { 
    $Digit       = GetResultFromRow( "DIGIT",        $TempRow, $TempDatabase );
    $AudioURL    = GetResultFromRow( "AUDIOURL",     $TempRow, $TempDatabase ); 
    $Destination = GetResultFromRow( "DESTINATION",  $TempRow, $TempDatabase );
    $MenuName    = GetResultFromRow( "MENUNAME",     $TempRow, $TempDatabase );
    $ActionType  = GetResultFromRow( "ACTIONTYPE",   $TempRow, $TempDatabase );
    $Position    = GetResultFromRow( "MENUPOSITION", $TempRow, $TempDatabase );
	$UniqueID    = GetResultFromRow( "UNIQUEID",     $TempRow, $TempDatabase );
	
	//-----------------------------------------------------------
	// Check to see if we have a new item -- we are using a space
	// as the Digit variable when a completely new item is added.
	//-----------------------------------------------------------
	
	if ( ($Digit == " ") || ($AudioURL == " ") ) {
	  $NewEntry = "TRUE";
	}  // if statement
	
	//------------------------------------------------------------
	// We are going to use the Loopy loop variable as our 
	// number tracker for the form variables.
	//------------------------------------------------------------
	
	$TableString = $TableString . "<tr><td align=center>\n" .
				   "<input type=\"text\" name=\"Digit" . $Loopy . 
				   "\" value=\"$Digit\" size=\"4\" maxlength=\"1\" $ReadOnly>" . "</td>\n";
	
	$TableString = $TableString . "<td align=center>\n" .
				   "<input type=\"text\" name=\"AudioURL" . $Loopy . 
				   "\" value=\"$AudioURL\" size=\"15\" maxlength=\"150\" $ReadOnly>" . "</td>\n";

	$TableString = $TableString . "<td align=center>\n" .
				   "<input type=\"text\" name=\"Destination" . $Loopy . 
				   "\" value=\"$Destination\" size=\"15\" maxlength=\"150\" $ReadOnly>" . "</td>\n";
			
	//------------------------------------------------------------------------------
	// Do not bother listing the menu name unless we are viewing the Entire Database
	//------------------------------------------------------------------------------		
			
	if ($TempMenuName == "Entire Database") {
	  $TableString = $TableString . "<td align=center>\n" .
				     "<input type=\"text\" name=\"TheMenuName" . $Loopy . 
					 "\" value=\"$MenuName\" size=\"10\" maxlength=\"30\" $ReadOnly>" . "</td>\n";
	}  // if statement
	else { 
	  //----------------------------------------------------------------------------
	  // Somewhat unnecessary, but just fill the MenuName array with the menuname
	  // just in case we adjust thing later involving the display (i.e., we
	  // will continue to pass the menu names along, even though it is not necessary
	  //----------------------------------------------------------------------------
	
	  $TableString = $TableString . "<input type=\"hidden\" name=\"TheMenuName" . $Loopy . "\" value=\"$MenuName\">";
	}  // else statement		   
	
	//--------------------------------------------------------			   
	// Building up the select list for the ActionType variable
	// is a little more complex, because we want to make sure
	// the selected one is displayed and that there are
	// no duplicates in the list itself.  Thus we have to 
	// dynamically generate the drop down menu.
	//--------------------------------------------------------
		
     $TableString = $TableString . "<td align=center>\n" .
	 				"<select name=\"ActionType" . $Loopy ."\" size=\"1\">\n";
					
	//---------------------------------------------------------------------------
	// If the database entry is a valid ActionType, then make it the selected one
	//---------------------------------------------------------------------------			
					
	if ( in_array($ActionType, $ActionTypes) ) {

	  //----------------------------
	  // Set the selected ActionType
	  //----------------------------
	  
	  $TableString = $TableString . "<option selected>$ActionType";
	  
	  //----------------------------------
	  // Build the rest of the select list
	  //----------------------------------
	
	  for ($NewLoopy=0; $NewLoopy < $NumberOfActionTypes; $NewLoopy++) {
	    if ($ActionType != $ActionTypes[$NewLoopy]) { 
		  $TableString = $TableString . "<option>$ActionTypes[$NewLoopy]\n";
		}  // if statement
	  }  // for statement 
	}  // if statement
	else { 
	  //-----------------------------------------------------
	  // Database entry was either invalid or blank, so make
	  // the default menu, with Call as the default selected.
	  //-----------------------------------------------------
	
	  for ($NewLoopy=0; $NewLoopy < $NumberOfActionTypes; $NewLoopy++) {
	    $TableString = $TableString . "<option>$ActionTypes[$NewLoopy]\n";
	  }  // for statement
	}  // else statement
	
	//-------------------------------
	// Finish up the Select list menu
	//-------------------------------
	
	$TableString = $TableString . "</select></td>\n";
		
	$TableString = $TableString . "<td align=center>\n" .
				   "<input type=\"text\" name=\"Position" . $Loopy . 
				   "\" value=\"$Position\" size=\"5\" maxlength=\"2\" $ReadOnly>" . "</td>\n";
				   
    //----------------------------------------------------------------------------				   
    // Do not display the delete checkbox if we are displaying the Entire Database
	//----------------------------------------------------------------------------				   
				   
	if ($TempMenuName != "Entire Database") {
	  $TableString = $TableString . "<td align=center>\n" . 
				     "<input type=\"checkbox\" name=\"Delete" . $Loopy . "\" value=\"DummyValue\">" .
				     "</td>\n";	
	}  // else statement

	//--------------------------------------------------
	// It will be necessary to remember the UniqueID for
	// when we change the result set in the database.
	//--------------------------------------------------
			   
	$TableString = $TableString . "<input type=\"hidden\" name=\"UniqueID" . $Loopy . "\" value=\"$UniqueID\">";			   

    $TableString = $TableString . "</TR>";
    $Loopy++;
  }  // while statement
  
  //-------------------------------------------------------
  // Set the number of rows to pass into the workhorse page
  //-------------------------------------------------------
  
  $NumberOfRows = $Loopy;
  
  //----------------------------------------------------------
  // Check to see if there was an invalid menu name requested.
  //----------------------------------------------------------

  if ($Loopy == 0) {
    $BadMenuName = "TRUE";
  }  // if statement
  else {
    $BadMenuName = "FALSE";
  }  // else statement
  
  //-------------------------
  // Build HTML table headers
  //-------------------------
  
  echo "<table width=850 cellspacing=0 cellpadding=0>";
  echo "<tr><td align=left valign=top>";
  echo "<img src=\"background_curve.gif\" width=\"28\" height=\"33\" alt=\"\" border=\"0\">";
  echo "</td><td valign=middle>";
  echo "<A HREF=\"http://www.voxeo.com\" TARGET=\"_blank\"><img src=\"logo.gif\" " .
       "width=244 height=70 alt=\"voxeo\" border=0></A>";
  echo "</td><td valign=middle align=right>";
  echo "<img src=\"top_slogan.gif\" width=523 height=58 border=0>";
  echo "</td></tr></table><p>";
	 
  echo "<table width=850 align=Center bgcolor=#264c73 border=0 cellspacing=0 cellpadding=0>\n";
  echo "<tr><td width=182 valign=top align=center bgcolor=#264c73>\n";

  //------------------------------------------
  // Dynamically build up a list of menu links
  //------------------------------------------
  
  echo "<table width=182 valign=top cellpadding=0 cellspacing=0 " .
  	   "align=center bgcolor=#264c73 border=0>\n";
  echo "<tr><td align=center><font color=White size=5 face=Arial>";
  echo "<img src=\"top_left.gif\" width=182 height=134 border=0>";
  echo "<br>OPTIONS<p></td></tr></table><p>\n";
  
  for ($Loopy = 1; $Loopy <= $NumberOfMenus; $Loopy++) {
    
    echo "<a href=\"$Path" . "autoattendantadmin.php?OS=" . $HTTP_GET_VARS["OS"] . 
		 "&MenuName=$MenuNames[$Loopy]\" " .
	     "onMouseOver=\"return display('   Change the active menu to $MenuNames[$Loopy]')\">" .
		 "<font color=White size=3 face=Helvetica><b>$MenuNames[$Loopy]</b></a><br>\n";
  }  // for statement
  
  echo "<br>";
  
  echo "<a href=\"$Path" . "autoattendantadmin.php?OS=" . $HTTP_GET_VARS["OS"] . "\" " .
	   "onMouseOver=\"return display('   Display the entire database')\">" .
	   "<font color=White size=3 face=Helvetica><b>Entire Database</b></a><p>\n";
	   
  //-------------------------------------------------------	   
  // Provide a link for adding a new menu item.
  // This is only available if a specific menu is selected.
  //-------------------------------------------------------   
	   
  if ( ($MenuNameToDisplay != "") && ($BadMenuName == "FALSE") ) {
    echo "<a href=\"$Path" . "autoattendantworkhorse.php?OS=" . $HTTP_GET_VARS["OS"] . 
		 "&AddEntry=TRUE&MenuName=$MenuNameToDisplay\" " .
	     "onMouseOver=\"return display('   Add a new entry to this specific menu')\">" .
	     "<font color=White size=3 face=Helvetica><b>Add Entry</b></a><br>\n";
  
  }  // if statement
  
  //--------------------------
  // Display the Add Menu item
  //--------------------------
  
  echo "<a href=\"$Path" . "autoattendantworkhorse.php?OS=" . $HTTP_GET_VARS["OS"] . 
  	   "&AddMenu=TRUE\" " .
	   "onMouseOver=\"return display('   Add an entirely new menu')\">" .
	   "<font color=White size=3 face=Helvetica><b>Add Menu</b></a><p>\n";  
 
  echo "<img src=\"bottom_left.gif\" width=182 height=112 border=0>";
 
  echo "</td><td width=750 align=Center>\n";
  
  echo "<br><font color=#FFFFFF face=Arial size=5>\n";
  echo "<div align=Center>Welcome to the AutoAttendant Administration Page</div>\n";
  echo "</font><p>\n";
  
  echo "You have currently selected the menu" . " \"<font face=Helvetica color=#9999FF>" .
       "$TempMenuName<font face=Arial color=White>\" to display. <br>\n";
	   
  //----------------------------------------
  // Ensure that the verbage sounds correct.
  //----------------------------------------
	   
  if ($TempMenuName != "Entire Database") {
    echo "Any changes you make here are <B>Permanent</B>, so proceed carefully.<p>\n";
  }  // if statement
  else {
    echo "<br>";
  }  // else statement
	   
  if ( ($NewEntry == "TRUE") && ($TempMenuName != "Entire Database") ) {
    echo "<table width=400 align=center><tr><td>\n" .
	     "<font face=Helvetica size=1 color=#FFFFFF>There are newly added items on this menu.  You will want " .
	     "to fill appropriate data into the fields before running Auto Attendant again.</font><p>\n" .
		 "</td></tr></table>";
  }  // if statement
  
  if ($BadMenuName == "FALSE") {
    //---------------------
    // Begin form structure
    //---------------------
  
    echo "<form action=\"autoattendantworkhorse.php?OS=" . $HTTP_GET_VARS["OS"] . 
		 "&MenuName=$MenuNameToDisplay\" method=\"post\" name=\"AdminForm\">\n";
	
    if ($TempMenuName == "Entire Database") {
      $TableWidth = 650;
    }  // if statement
    else {
      $TableWidth = 600;
    }  // else statement	
    
    echo "<TABLE width=$TableWidth border=0 align=Center cellpadding=0 cellspacing=0><TR>\n" .
         "<TH><font size=2 color=#9999FF>Digit</TH>\n" .
	     "<TH><font size=2 color=#9999FF>AudioURL</TH>\n" . 
         "<TH><font size=2 color=#9999FF>Destination</TH>\n";
		 
	//-----------------------------------------------------------------	 
	// We do not want the header if a specific menu is being displayed.
	//-----------------------------------------------------------------	 
		 
	if ($TempMenuName == "Entire Database") { echo "<TH><font size=2 color=#9999FF>MenuName</TH>\n"; }
	
	echo "<TH><font size=2 color=#9999FF>ActionType</TH>\n" .
	     "<TH><font size=2 color=#9999FF>Position</TH>\n";
		 
	//---------------------------------------------------------------------	 
	// We do not want the header if the entire database is being displayed.
	//---------------------------------------------------------------------	 
		 
	if ($TempMenuName != "Entire Database") { echo "<TH><font size=2 color=#9999FF>Delete?</TH>\n"; }
	     
	echo "</TR>\n"; 
    echo "$TableString</table>\n";
	
	//---------------------------------------------------------------------
	// We do not want the buttons if the entire database is being displayed
	//---------------------------------------------------------------------
	
	if ($TempMenuName != "Entire Database") {
      //-------------------------------------
      // Display the Submit and Reset buttons
      //-------------------------------------
  
      echo "<br><table align=center width=500><tr>\n";
      echo "<td align=center><input type=\"Submit\" name=\"Submit\" value=\"Save my changes\"></tr>\n" .
         "<td align=center><input type=\"Reset\" value=\"Reset my changes\"></tr>\n"; 
      echo "</table>\n";
	}  // if statement

	//------------------------------------------------------------
	// We have to send in the number of rows to the workhorse page
	//------------------------------------------------------------
	
    echo "<input type=\"hidden\" name=\"NumberOfRows\" value=\"$NumberOfRows\">\n";

    //----------------
    // End of the form
    //----------------
  
    echo "</form>"; 
	
  }  // if statement
  else {
    echo "<table width=750 border=0 align=center><tr><td align=center>\n";    
	echo "<font size=2 face=Helvetica color=Lime>The menu name you have requested does not exist.";
	echo "</td></tr></table>\n";
  }  // else statement
  
  echo "<p>";
  
  echo "</td></tr></table>";
 
  //------------------------------
  // Close the Database connection
  //------------------------------
 
 CloseDatabase( $TempConnection ); 
  
 exit();
}  // function statement

DisplayDatabaseTable( $HTTP_GET_VARS["MenuName"] );


?>  
             

</body>
